function [verteilung,koords,flag] = Distribution(random_variable, anz, N, R)
   % random_variable(n), n= 1 ... anz
   % N = number of slots for distribution,  N positive
   % random_variable lies between 0 and R
   % Output: verteilung = distribution of the random variable
   %         koords = x-coordinates for the distribution
   %         flag  (0= ok) (1= out of bounds)
   
verteilung= zeros(1,N+1);
flag=0;  
%N_halbe = N/2;
slotwidth = R/N;
oneover_slotwidth = (1/slotwidth);
koords=0:slotwidth:R;

for count=1:anz      
           if random_variable(count) > R  ||     random_variable(count) < 0         
               flag=1;
               disp('Warning: random_variable  out of bounds')
           end
           index = 1 + round(random_variable(count)/slotwidth); % random_variable between 0 and R
        
           if 1 <= index && index <= N+1
               verteilung(index)= verteilung(index)+oneover_slotwidth/anz;
           end
end   