function [verteilung,koords,flag] = Distribution_sym(random_variable, anz, N, R)
   % random_variable(n), n= 1 ... anz
   % N = number of slots for distribution, N/2 negative and N/2 positive
   % random_variable lies between -R and R
   % Output: verteilung = distribution of the random variable
   %         koords = x-coordinates for the distribution
   %         flag  (0= ok) (1= out of bounds)
   
verteilung= zeros(1,N+1);
flag=0;  
N_halbe = N/2;
slotwidth = R/N_halbe;
oneover_slotwidth = (1/slotwidth);
koords=-R:slotwidth:R;

for count=1:anz      
           if abs(random_variable(count)) > R             
               flag=1;
               disp('Warning: random_variable  out of bounds')
           end
           index = N_halbe + 1 + round(random_variable(count)/slotwidth); % random_variable between -R and R
        
           if 1 <= index && index <= N+1
               verteilung(index)= verteilung(index)+oneover_slotwidth/anz;
           end
end   