function [ ] = Update_myfund(factor)
%Update of all the Fundamental  Investors

% Cowardice

global M_FUND h;
global P_AKT P_NULL SIG_PREV_FUND SIG_AKT_FUND;
global FUND_S  FUND_C FUND_P FUND_K FUND_H;
global anzKwechsel_FUND anzHwechsel_FUND;
global FACTOR_QUOT FUND_THRESHOLD;
global MONEY_FUND positions_FUND;
global RAUSCHEN;

quot_investor=zeros(1,M_FUND);
qq=zeros(1,M_FUND);

%amount to buy/sell
quot= P_AKT/P_NULL;

if quot < 1 
    quot = 1/quot;
end

for i=1:M_FUND,  %investor i can observe quot only approximately
    quot_investor(i) = quot + RAUSCHEN(i);
    qq(i)= max(1,round(FACTOR_QUOT*(quot_investor(i)-1)));
end

fund_s_save = FUND_S;
sig=zeros(1,M_FUND);
c_hat=zeros(1,M_FUND);
switching=zeros(1,M_FUND);
%qq= round(0.5 + FACTOR_QUOT*(quot-1)*(quot-1));


for i=1:M_FUND,
   absdiff= abs(FUND_S(i)-round(SIG_AKT_FUND));
   if absdiff > 0.5
      sig(i) = 1;   %Coverdice gets enlarged
   else sig(i) = 0;
   end
   c_hat(i)= FUND_C(i) + h* absdiff * sig(i);
end



for i=1:M_FUND
  if quot_investor(i) > FUND_THRESHOLD  % only if the market is far from the fair value: invest new or reduce
     if P_AKT > P_NULL  % market price over fair price; in any case only short positions allowed
         % check for switching activity 
         if ~( FUND_P(i)/(1+FUND_H(i)) <= P_AKT  && P_AKT <= FUND_P(i)*(1+FUND_H(i)) )   % switch because outside comfort interval       
            if P_AKT > FUND_P(i)*(1+FUND_H(i)) %  break out bullish;   
               FUND_S(i) = min(0,FUND_S(i) - qq(i)); %  act anticyclic: more short positions!
               switching(i) = 1; 
               anzHwechsel_FUND=anzHwechsel_FUND+1;
            else % break out bearish;
               FUND_S(i) = min(0,FUND_S(i) + qq(i));  %act anticyclic: reduce short postions
               switching(i) = 1; 
               anzHwechsel_FUND=anzHwechsel_FUND+1;
            end
         else
            if (c_hat(i) > FUND_K(i))  %cowardice action 
                FUND_S(i) =  min(0,FUND_S(i) - sign(FUND_S(i)-round(SIG_AKT_FUND))); % position gets closer to SIG_AKT_FUND  
                switching(i) = 1; 
                anzKwechsel_FUND = anzKwechsel_FUND+1;
            end
         end
     else % market price under fair price; in any case only long positions allowed
         % check for switching activity 
          if ~( FUND_P(i)/(1+FUND_H(i)) <= P_AKT  && P_AKT <= FUND_P(i)*(1+FUND_H(i)) )   % switch because outside comfort interval      
               if P_AKT > FUND_P(i)*(1+FUND_H(i)) %  break out bullish;  
                  FUND_S(i) = max(0,FUND_S(i) - qq(i)); %  act anticyclic: more short positions!
                  switching(i) = 1; 
                  anzHwechsel_FUND=anzHwechsel_FUND+1;
               else
                  FUND_S(i) = max(0,FUND_S(i) + qq(i)); % break out bearish; act anticyclic: reduce short postions
                  switching(i) = 1; 
                  anzHwechsel_FUND=anzHwechsel_FUND+1;
               end             
         else
            if (c_hat(i) > FUND_K(i))  %cowardice action 
                FUND_S(i) =  max(0,FUND_S(i) - sign(FUND_S(i)-round(SIG_AKT_FUND))); % position gets closer to SIG_AKT_FUND
                switching(i) = 1; 
                anzKwechsel_FUND = anzKwechsel_FUND+1;
            end
         end
     end
  else % the market is close to fair value; no new investments, only reduction of investment 
      
      if  FUND_S(i) > 0   % only selling possible
         if  P_AKT > FUND_P(i)*(1+FUND_H(i)) % break out bullish; anticyclic action makes sense
             switching(i) = 1; 
             anzHwechsel_FUND=anzHwechsel_FUND+1;
             FUND_S(i) = max(0,FUND_S(i) - qq(i)); %  act anticyclic: reduce long positions - maximal to zero
         else
              if c_hat(i) > FUND_K(i)  %cowardice action 
                   switching(i) = 1; 
                   anzKwechsel_FUND = anzKwechsel_FUND+1;
                   FUND_S(i) =  FUND_S(i) - 1; % position gets closer to 0
              end
        end
      end
      if  FUND_S(i) < 0   % only buying possible
        if  P_AKT < FUND_P(i)/(1+FUND_H(i)) % break out bearish; anticyclic action makes sense
             switching(i) = 1; 
             anzHwechsel_FUND=anzHwechsel_FUND+1;
             FUND_S(i) = min(0,FUND_S(i) + qq(i)); % act anticyclic: reduce short positions - maximal to zero
        else
          if c_hat(i) > FUND_K(i)  %cowardice action 
             switching(i) = 1; 
             anzKwechsel_FUND = anzKwechsel_FUND+1;
             FUND_S(i) =  FUND_S(i) + 1; % position gets closer to 0
          end          
        end
      end 
  end
end


%Update of variables
  for i=1:M_FUND
    if switching(i) == 1
       FUND_P(i) = P_AKT;
       FUND_C(i) = 0;
       [kk,hh] = mysetK_and_H_LAM();
       FUND_H(i)=factor*hh;
       FUND_K(i)=factor*kk;
       MONEY_FUND(i)= MONEY_FUND(i) - (FUND_S(i) - fund_s_save(i)) * P_AKT; % update money position   
       positions_FUND(i)= positions_FUND(i)+ abs(FUND_S(i) - fund_s_save(i));
    else
        FUND_C(i) = c_hat(i);
    end
  end


end

