function [] = mylamba(stepsinp,paramfile)% One Market Model
% Lamba Investors and Fundamentals
% Input stepsinp: number of time steps
% paramfile: name of parameter-file

%clear all;

global M M_FUND h steps comp;
global P_AKT  P_NULL P_NEWS;
global SIG_PREV SIG_AKT SIG_PREV_LAM SIG_AKT_LAM SIG_PREV_FUND SIG_AKT_FUND;
global LISTE MACD_LIST;
global LAM_S LAM_C LAM_P LAM_K LAM_H;       % lamba investors
global FUND_S  FUND_C FUND_P FUND_K FUND_H; % fundamental investors investors
global anzKwechsel anzHwechsel anzHwechsel_FUND anzKwechsel_FUND;
global FACTOR_QUOT FUND_THRESHOLD;
global MONEY_LAMB MONEY_FUND EQUITY_LAMB EQUITY_FUND;
global positions_LAMB positions_FUND;
global EPS_THRESHOLD RAUSCHEN;
global RISK_LAM_S RISIKO;
global OUTPUTFILE RANDOMINPUTFILE OUTPUTDATA;
global InpData InpDataFl InpDataVec InpDataMode ANZ_COMP;
global Hminus Hplus Kminus Kplus;

steps=stepsinp;
InpDataMode = zeros(1,4);  % List of Models to compute
                           % 0 for  model A   only old mylamba investors
                           % 1 for  model A*  only mylamba investors with RISIKO 
                           % 2 for model B    old mylamba and myfund investor
                           % 3 model B*       mylamba investors with RISIKO and myfund investors
                           % -1 no model specified   
InpData =zeros(2,3);       % M, \tilde M, RHO
                           % Alpha, Beta,  p_start
InpDataFl =zeros(3,4);     % Kappa, \tilde Kappa, Gamma, Delta
                           % K^-, K^+, H^-, H^+
  % h, EPSILON, Factor_KH (faktor scales K^\pm and K^\pm), not assigned
InpDataVec = zeros(1,5);   % Discrete (0=normally distributed, 1= discrete number generator)
                           % Output Statistics (1=yes,0=no)
                           %  Output Mode (0= no, 1= write tick file, 2=write data, 3= both),
                           % Output factor (scales the time for tick data)
                           %  Input Mode, 
                           
Read_Parameter_File(paramfile);

check_data=0;

if check_data ==1
  ANZ_COMP
  InpDataMode
  InpData
  InpDataFl
  InpDataVec
end

%pause

M= InpData(1,1); % Anzahl Lamba Investors
TildeM = InpData(1,2);
rho= InpData(1,3);

AUSWAHL = InpDataMode(1);  
set_model(AUSWAHL, TildeM, rho);                  % set RISKO and M_FUND

%kappa = 1/M;
%Faktor = 40; % maximales Verh?ltnis kappa delta sig / sqrt_of_two_times_h
%sqrt_of_two_times_h = 0.5/(M*M);
h = InpDataFl(3,1);
sqrt_of_two_times_h = sqrt(2*h);
%kappa_null = Faktor/2 * sqrt_of_two_times_h;
kappa_null = InpDataFl(1,1);
kappa_tilde = InpDataFl(1,2);
p_start=InpData(2,3);

FACTOR_QUOT=InpData(2,1);   % alpha: parameter for the function f to scale fundamental investors deals
factor_FUND_LAM=InpData(2,2); % beta:  factor to init coverdice and range threshold
FUND_THRESHOLD =InpDataFl(1,3); % Gamma: Threshold when fundamental investors get active
%feinheit=4;
VOLATILITY=InpDataFl(1,4);   % delta
%VOLATILITY=0.2/feinheit;

EPS_THRESHOLD = InpDataFl(3,2); % Epsilon: Individual Threshold of  fundamental investors is perturbed
FaktorHK=InpDataFl(3,3);        % faktor scales K^\pm and K^\pm
Discrete = InpDataVec(1);      % if == 1 use discrete random generator, if not normally distributed
Statistics = InpDataVec(2);    % if == 1 output statistics

Output_to_file = InpDataVec(3);                %if == 1 output to  OUTPUTFILE on tick basis
%OUTPUTFILE =  'DAX.tick';

Outputfactor_ticktime  = InpDataVec(4);      %  scales the time for tick data

%Input file random generator
RandomInput_from_file = InpDataVec(5);                %if == 1 read random input from file
                                          %if == 0 random generator
                                          %if == 2 write random generator
%RANDOMINPUTFILE =  'input_random.mat';?
Hminus = InpDataFl(2,3)*FaktorHK;
Hplus = InpDataFl(2,4)*FaktorHK;
Kminus = InpDataFl(2,1)*FaktorHK;
Kplus = InpDataFl(2,2)*FaktorHK;


if check_data ==1
   M
   TildeM
   rho
   AUSWAHL
   h
   kappa_null 
   kappa_tilde
   p_start
   FACTOR_QUOT
   factor_FUND_LAM
   FUND_THRESHOLD
   VOLATILITY
   EPS_THRESHOLD 
   Discrete
   Statistics
   Output_to_file
   RandomInput_from_file
   OUTPUTFILE
   RANDOMINPUTFILE
   Hminus 
   Hplus 
   Kminus 
   Kplus
end
%pause


% memory allocation

MONEY_LAMB = zeros(1,M);
positions_LAMB = zeros(1,M);
total_LAM= zeros(1,M);
RISK_LAM_S= zeros(1,M);
MONEY_FUND= zeros(1,M_FUND);
positions_FUND= zeros(1,M_FUND);
total_FUND = zeros(1,M_FUND);
RAUSCHEN = zeros(1,M_FUND);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% XXXXXXXXXXXXXXXXXXXXXXXXXXX Preallocate space XXXXXXXXXXXXXXXXXXXXXX
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Preallocate space
LISTE =zeros(steps,8);  %[P_AKT, P_NULL, P_NEWS, SIG_AKT, SIG_AKT_LAM, SIG_AKT_FUND, activity_LAM, activity_FUND ]
EQUITY_LAMB = zeros(1,steps);
EQUITY_FUND= zeros(1,steps);
EQUITY_LAMB_PER_TRADE = zeros(1,steps);
EQUITY_FUND_PER_TRADE = zeros(1,steps);
price_null = zeros(1,steps);


% preset news GAUSS process
price_null(1)=p_start;

%RandomInput_from_file = 0;                %if == 1 read random input from file
                                          %if == 0 random generator
                                          %if == 2 write random generator
%RANDOMINPUTFILE =  'input_random.mat';
if RandomInput_from_file == 1
   load(RANDOMINPUTFILE,'Z_PRE');
else
  for count=2:steps,
    % Update New Price
    if Discrete == 1  
       ZZ = round(2*rand);
       WW = round(rand);

       if ZZ == 1 
         Z=0;
       else 
         if WW == 1 
           Z=1;
         else Z=-1;
         end   
       end
    else
      Z=randn;
    end
    Z_PRE(count) =  Z;
  end
end

if RandomInput_from_file == 2
    save RANDOMINPUTFILE Z_PRE
end

for count=2:steps,
    price_null(count) = price_null(count-1) * exp(VOLATILITY * sqrt_of_two_times_h * Z_PRE(count));
end

koord=1:steps;
figure(15)
plot(koord,price_null,'k--')
set(gca,'XTick',0:steps/5:steps,'fontSize',12)
set_title(AUSWAHL, 14,', fair price')    
disp('news process ok?')
pause

for j = 1:ANZ_COMP, 
    
    AUSWAHL=InpDataMode(j);                               % which model
    comp = AUSWAHL;
    set_model(AUSWAHL, TildeM, rho);                      % set RISKO and M_FUND
   
% main part

if M_FUND > 0
    kappa= kappa_tilde;
else
    kappa= kappa_null;
end

MONEY_LAMB = zeros(1,M);
positions_LAMB = zeros(1,M);
total_LAM= zeros(1,M);
RISK_LAM_S= zeros(1,M);
MONEY_FUND= zeros(1,M_FUND);
positions_FUND= zeros(1,M_FUND);
total_FUND = zeros(1,M_FUND);
RAUSCHEN = zeros(1,M_FUND);
LISTE =zeros(steps,8);  %[P_AKT, P_NULL, P_NEWS, SIG_AKT, SIG_AKT_LAM, SIG_AKT_FUND, activity_LAM, activity_FUND ]
EQUITY_LAMB = zeros(1,steps);
EQUITY_FUND= zeros(1,steps);
EQUITY_LAMB_PER_TRADE = zeros(1,steps);
EQUITY_FUND_PER_TRADE = zeros(1,steps);

wbar=waitbar(0,'Computing . . .');

anzKwechsel=0;
anzHwechsel=0;
anzKwechsel_FUND=0;
anzHwechsel_FUND=0;


% Initializing Price and Sentiment
P_AKT = p_start; P_NULL = P_AKT; P_NEWS= P_NULL; 
SIG_PREV = 0; SIG_PREV_LAM=0; SIG_PREV_FUND=0; SIG_AKT_FUND=0;


% Initializing LAMBA Investors (LAM_S LAM_C LAM_P LAM_K LAM_H)
init_mylamba();
for i = 1:M,
  total_LAM(i)=MONEY_LAMB(i)+LAM_S(i)*P_AKT;
  positions_LAMB(i)= abs(LAM_S(i));
end
EQUITY_LAMB(1)=sum(total_LAM);
trades_LAMB= sum(positions_LAMB); % equals number of full trades = 2* number of half turns
if  trades_LAMB > 0
   EQUITY_LAMB_PER_TRADE(1)=EQUITY_LAMB(1)/trades_LAMB;
end

% Initializing FUND Investors (FUND_S FUND_C FUND_P FUND_K FUND_H)
if M_FUND > 0
  init_myfund(factor_FUND_LAM);   %argument: factor for multiple FUND_K/LAM_K and FUND_H/LAM_H
  for i = 1:M_FUND,
    total_FUND(i)=MONEY_FUND(i)+FUND_S(i)*P_AKT;
    positions_FUND(i)=  abs(FUND_S(i));
    RAUSCHEN(i) = EPS_THRESHOLD * randn;  % Individual Threshold of  fundamental investors is perturbed
  end
  EQUITY_FUND(1)=sum(total_FUND);
  trades_FUND= sum(positions_FUND); 
  if  trades_FUND > 0
     EQUITY_FUND_PER_TRADE(1)=EQUITY_FUND(1)/trades_FUND;
  end
end

activity_LAM = 0;
activity_FUND = 0;

v=[P_AKT, P_NULL, P_NEWS, SIG_PREV, SIG_PREV_LAM, SIG_PREV_FUND, activity_LAM, activity_FUND ];
LISTE(1,:)=v;



for count=2:steps,
        waitbar(count/steps)

% Step n -> n+1

% store the relative sigmas
SIG_AKT_LAM = (sum(LAM_S) )/(M);

if M_FUND > 0
  SIG_AKT = (sum(LAM_S) + sum(FUND_S))/(M+M_FUND);
  SIG_AKT_FUND = (sum(FUND_S))/(M_FUND);
else
  SIG_AKT =  SIG_AKT_LAM;
end

delta_sigma = SIG_AKT - SIG_PREV;

% Update New Price
Z = Z_PRE(count);

retracement=0;
newsscale=0;
Z_news = newsscale*sin(count*2*pi/steps);
%P_AKT = P_AKT * exp(VOLATILITY*(sqrt_of_two_times_h * Z + kappa * delta_sigma));
P_AKT = P_AKT * exp(VOLATILITY*(sqrt_of_two_times_h * (Z+Z_news) + kappa * delta_sigma - retracement * SIG_AKT));


P_NULL = P_NULL * exp(VOLATILITY * sqrt_of_two_times_h * (Z+Z_news));
P_NEWS = P_NEWS * exp(VOLATILITY * sqrt_of_two_times_h * Z_news);

    
% Update Lamba Investors (LAM_S LAM_C LAM_P LAM_K LAM_H)
Update_mylamba();
% Update Lamba Investors (FUND_S FUND_C FUND_P FUND_K FUND_H)


if M_FUND > 0
  Update_myfund(factor_FUND_LAM);
end

% Update Sentiment
SIG_PREV = SIG_AKT;
SIG_PREV_LAM = SIG_AKT_LAM;
SIG_PREV_FUND = SIG_AKT_FUND;


act_LAM_now = anzKwechsel + anzHwechsel;
act_FUND_now = anzKwechsel_FUND + anzHwechsel_FUND;

v=[P_AKT, P_NULL, P_NEWS, SIG_PREV, SIG_PREV_LAM, SIG_PREV_FUND, act_LAM_now-activity_LAM, act_FUND_now-activity_FUND];
LISTE(count,:)=v;

activity_LAM = act_LAM_now;
activity_FUND = act_FUND_now;

% save equity
trades_LAMB= sum(positions_LAMB);
trades_LAMB_open = sum(abs(LAM_S));

for i = 1:M,
  total_LAM(i)=MONEY_LAMB(i)+LAM_S(i)*P_AKT;
end
EQUITY_LAMB(count)=sum(total_LAM);
quot=trades_LAMB+ trades_LAMB_open;  % number of half turns
if quot> 0
  EQUITY_LAMB_PER_TRADE(count) = 2*EQUITY_LAMB(count)/quot; 
end

if M_FUND>0
  trades_FUND= sum(positions_FUND);
  trades_FUND_open = sum(abs(FUND_S));

  for i = 1:M_FUND,
    total_FUND(i)=MONEY_FUND(i)+FUND_S(i)*P_AKT;
  end
  EQUITY_FUND(count)=sum(total_FUND);
  quot=trades_FUND+ trades_FUND_open;

  if quot> 0
    EQUITY_FUND_PER_TRADE(count) = 2*EQUITY_FUND(count)/quot;
  end  
end
 


end %count
close(wbar)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  OUTPUT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


LISTE;

price      = LISTE(:,1);
price_null = LISTE(:,2);
price_news = LISTE(:,3);

sig=(M+M_FUND)*LISTE(:,4);
sig_lam=M*LISTE(:,5);

if M_FUND > 0
  sig_fund=M_FUND*LISTE(:,6);
end



koord=1:steps;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Figure 1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1+20*comp)
plot(koord,price,'b','LineWidth',2)
set(gca,'XTick',0:steps/5:steps,'fontSize',12)
%set(gca,'XTickLabel',{'0','2000','0','pi/2','pi'})
%axis([0 10000 4000 6000])
set_title(AUSWAHL, 14,', price evol')    

hold on
plot(koord,price_null,'k--')
hold off
hold on
   %plot(koord,price_news,'y')
hold off


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Figures Statistics
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Output statistics
if Statistics == 1
  output_statistics(AUSWAHL,comp);
end
% end Output statistics


% Output equity
figure(11+20*comp)
plot(koord,EQUITY_LAMB,'b')
set(gca,'XTick',0:steps/5:steps,'fontSize',12)
set_title(AUSWAHL, 14, ', equity')    
%title(['steps = ' int2str(steps) ' blue:M = ' int2str(M) ' black:M_FUND = ' int2str(M_FUND) ' Equity Evol '],'fontSize',16)
hold on
plot(koord,EQUITY_FUND,'k')
hold off

% Output equity per trade

figure(12+20*comp)
plot(koord,EQUITY_LAMB_PER_TRADE,'b')
set(gca,'XTick',0:steps/5:steps,'fontSize',12)
set_title(AUSWAHL, 14, ', equity per trade')    
%title(['steps = ' int2str(steps) ' blue:M = ' int2str(M) ' black:M_FUND = ' int2str(M_FUND) ' Equity per trade Evol '],'fontSize',16)
hold on
plot(koord,EQUITY_FUND_PER_TRADE,'k')
hold off

% Output to file
if Output_to_file == 1 || Output_to_file == 3
    activity_LAM = LISTE(:,7);
    activity_FUND = LISTE(:,8);
    activity= (activity_FUND/M_FUND + activity_LAM/M)/2
    
    write_to_file(steps,price,activity,Outputfactor_ticktime);
end
if Output_to_file == 2 || Output_to_file == 3
    save OUTPUTDATA LISTE
end
    



%   if comp < ANZ_COMP 
%     %Z_PRE
%     disp('next comp?')
%     comp  
%     %pause
%   end

end %for comp

output_param= 1;

if output_param ==1
  fprintf(1,'%s\n',paramfile)  
  fid = fopen(paramfile, 'rt');
  y = 0;
  while feof(fid) == 0 && y <= 20
    y=y+1;
    tline = fgetl(fid);   
    %line_store(y,:) = tline;
    fprintf(1,'%s\n',tline)
  end
end

