function [ ] = output_statistics(AUSWAHL, comp)

global LISTE M M_FUND steps;
  
  comp_price_price_null = zeros(1,steps);
  
  price_return = zeros(1,steps);
  price_return_null = zeros(1,steps);
  price_return_abs = zeros(1,steps);
  price_return_null_abs = zeros(1,steps);
  
  price_return_one = zeros(1,steps);
  price_return_null_one = zeros(1,steps);
  price_return_abs_one = zeros(1,steps);
  price_return_null_abs_one = zeros(1,steps);
  
  price      = LISTE(:,1);
  price_null = LISTE(:,2);
  activity_LAM = LISTE(:,7);
  activity_FUND = LISTE(:,8);
  
  koord=1:steps;
  
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%  activity LAM versus FUND 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  


  figure(7+20*comp)
  plot(koord,activity_LAM/M,'b:') 
   set_title(AUSWAHL, 14, ', activity')    
   set(gca,'XTick',0:steps/5:steps,'fontSize',12)
  %title(['activity FUND (r) versus activity LAM (b) : steps = ' int2str(steps) ' M = ' int2str(M) ' M_F = ' int2str(M_FUND)],'fontSize',16)
  hold on
  plot(koord,activity_FUND/M_FUND,'r','LineWidth',1.4)
  hold off  
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
% comp of price and price_null  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  

  for count=1:steps
           % comp of price and price_null
           comp_price_price_null(count) = (price(count)/price_null(count)-1);
  end           
  
  R=0.5;
  N=1000;
  [verteilung_comp,y_neu,flag]=Distribution_sym(comp_price_price_null, steps, N, R);

  % Figure:comparison distribution
  figure(8+20*comp)
  plot(y_neu,verteilung_comp,'b')
  set(gca,'XTick',-R:R/2:R,'fontSize',12)
   % title(['comp distribution (r): steps = ' int2str(steps) ' M = ' int2str(M) ' M_F = ' int2str(M_FUND)],'fontSize',16)
  set_title(AUSWAHL, 14,', comp')  
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
% price_return  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  

  time_delay_pricereturn=10; 
  for count=1:steps
           if count> time_delay_pricereturn
             price_return(count)=(price(count)/price(count-time_delay_pricereturn))-1;
             price_return_null(count)=(price_null(count)/price_null(count-time_delay_pricereturn))-1;             
           else
             price_return(count)=(price(count)/price(1))-1;
             price_return_null(count)=(price_null(count)/price_null(1))-1;
           end
           price_return_abs(count)=abs(price_return(count));
           price_return_null_abs(count)=abs(price_return_null(count));
  end   
 

  %Figure: price return  
  figure(3+20*comp)
  plot(koord,price_return,'r:','LineWidth',1.2) 
  set_title(AUSWAHL, 14,', re evol')    
  set(gca,'XTick',0:steps/5:steps,'fontSize',12)
  %title(['10 periods price return evolution (r) versus price returnnull (b) : steps = ' int2str(steps) ' M = ' int2str(M) ' M_F = ' int2str(M_FUND)],'fontSize',16)
  hold on
  plot(koord,price_return_null,'b')
  hold off 


  R=0.02;
  N=1000;
  [verteilung2,y_neu,flag]=Distribution_sym(price_return, steps, N, R);
  [verteilung2_null,y_neu,flag]=Distribution_sym(price_return_null, steps, N, R);

  %Figure: price return  distribution
  figure(4+20*comp)
  plot(y_neu,verteilung2,'r','LineWidth',1.5)
  set_title(AUSWAHL, 14,', re dist')    
  %set_title()    
  %title('X')
  set(gca,'XTick',-R:R/2:R,'fontSize',12)
  %set(gca,'YTick',0:10000:30000,'fontSize',12)
  %title(['10 periods pricereturn distribution (r) versus distnull (b): steps = ' int2str(steps) ' M = ' int2str(M) ' M_F = ' int2str(M_FUND)],'fontSize',16)
  hold on
  plot(y_neu,verteilung2_null,'b:','LineWidth',1.4)
  hold off

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%  time depending Volatility short  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
time_delay=26;   
[vola]=TimeDepVola(price, steps, time_delay);
[vola_null]=TimeDepVola(price_null, steps, time_delay);

%volatility
   figure(5+20*comp)
   plot(koord,vola,'r:','LineWidth',1.2)  
   set_title(AUSWAHL, 14, ', vola evol')    
   set(gca,'XTick',0:steps/5:steps,'fontSize',12)
  %title(['volatility evolution (r) versus volanull (b): steps = ' int2str(steps) ' M = ' int2str(M) ' M_F = ' int2str(M_FUND)],'fontSize',16)
  hold on
  plot(koord,vola_null,'b')
  hold off

  R=0.02;
  N=1000;
  [verteilung_vola,y_neu,flag]=Distribution(vola, steps, N, R);
  [verteilung_vola_null,y_neu,flag]=Distribution(vola_null, steps, N, R);
  
%volatility distribution
  figure(6+20*comp)
  plot(y_neu,verteilung_vola,'r','LineWidth',1.4)
  set_title(AUSWAHL, 14, ', vola dist') 
  set(gca,'XTick',0:R/5:R,'fontSize',12)
  %title(['volatility distribution (r) versus vola null (b): steps = ' int2str(steps) ' M = ' int2str(M) ' M_F = ' int2str(M_FUND)],'fontSize',16)
  hold on
   plot(y_neu,verteilung_vola_null,'b:','LineWidth',1.2)
  hold off
  
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%  time depending Volatility long  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  

time_delay=1000;   
[vola]=TimeDepVola(price, steps, time_delay);
[vola_null]=TimeDepVola(price_null, steps, time_delay);

%volatility
   figure(9+20*comp)
   plot(koord,vola,'r:','LineWidth',1.2)  
   set_title(AUSWAHL, 14, ', vola evol')    
   set(gca,'XTick',0:steps/5:steps,'fontSize',12)
  %title(['volatility evolution (r) versus volanull (b): steps = ' int2str(steps) ' M = ' int2str(M) ' M_F = ' int2str(M_FUND)],'fontSize',16)
  hold on
  plot(koord,vola_null,'b','LineWidth',1.1)
  hold off

  R=0.05;
  N=1000;
  [verteilung_vola,y_neu,flag]=Distribution(vola, steps, N, R);
  [verteilung_vola_null,y_neu,flag]=Distribution(vola_null, steps, N, R);
  
%volatility distribution
  figure(10+20*comp)
  plot(y_neu,verteilung_vola,'r','LineWidth',1.4)
  set_title(AUSWAHL, 14, ', vola dist') 
  set(gca,'XTick',0:R/5:R,'fontSize',12)
  %title(['volatility distribution (r) versus vola null (b): steps = ' int2str(steps) ' M = ' int2str(M) ' M_F = ' int2str(M_FUND)],'fontSize',16)
  hold on
   plot(y_neu,verteilung_vola_null,'b:','LineWidth',1.2)
  hold off
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%  autocorrelation price_return  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
  time_delay = time_delay_pricereturn;
  maxlag=25;
  startplot=0;
  if steps > time_delay
    delta=zeros(1, steps-time_delay ); 
    delta_null=zeros(1, steps-time_delay ); 
    delta_abs=zeros(1, steps-time_delay ); 
    delta_null_abs =zeros(1, steps-time_delay ); 
    
    for count=1:steps-time_delay     
       delta(count) = price_return(count+time_delay)- price_return(count);
       delta_null(count) = price_return_null(count+time_delay)- price_return_null(count);
       delta_abs(count) = price_return_abs(count+time_delay)- price_return_abs(count);
       delta_null_abs(count) = price_return_null_abs(count+time_delay)- price_return_null_abs(count);
    end
 
    [auto] = Autocorrelation(delta,steps-time_delay,maxlag);
    [auto_null] = Autocorrelation(delta_null,steps-time_delay,maxlag);
    [auto_abs] = Autocorrelation(delta_abs,steps-time_delay,maxlag);
    [auto_null_abs] = Autocorrelation(delta_null_abs,steps-time_delay,maxlag);
    
    figure(18+20*comp)
    plot(startplot:1:maxlag,auto,'b')
    set_title(AUSWAHL, 14, ', autocorr') 
    set(gca,'XTick',0:maxlag/5:maxlag,'fontSize',12)
    hold on
    plot(startplot:1:maxlag,auto_null,'r:')
    hold off
    
     figure(19+20*comp)
    plot(startplot:1:maxlag,auto_abs,'b')
    set_title(AUSWAHL, 14, ', autocorr') 
    set(gca,'XTick',0:maxlag/5:maxlag,'fontSize',12)
    hold on
    plot(startplot:1:maxlag,auto_null_abs,'r:')
    hold off
  end
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%  autocorrelation price_return  one day
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
 time_delay_pricereturn=1; 
  for count=1:steps
           if count> time_delay_pricereturn
             price_return_one(count)=(price(count)/price(count-time_delay_pricereturn))-1;
             price_return_null_one(count)=(price_null(count)/price_null(count-time_delay_pricereturn))-1;             
           else
             price_return_one(count)=(price(count)/price(1))-1;
             price_return_null_one(count)=(price_null(count)/price_null(1))-1;
           end
           price_return_abs_one(count)=abs(price_return_one(count));
           price_return_null_abs_one(count)=abs(price_return_null_one(count));
  end   
 


  time_delay = time_delay_pricereturn;
  maxlag=25;
  startplot=0;
  if steps > time_delay
    delta=zeros(1, steps-time_delay ); 
    delta_null=zeros(1, steps-time_delay ); 
    delta_abs=zeros(1, steps-time_delay ); 
    delta_null_abs =zeros(1, steps-time_delay ); 
    
    for count=1:steps-time_delay     
       delta(count) = price_return_one(count+time_delay)- price_return_one(count);
       delta_null(count) = price_return_null_one(count+time_delay)- price_return_null_one(count);
       delta_abs(count) = price_return_abs_one(count+time_delay)- price_return_abs_one(count);
       delta_null_abs(count) = price_return_null_abs_one(count+time_delay)- price_return_null_abs_one(count);
    end
 
    [auto] = Autocorrelation(delta,steps-time_delay,maxlag);
    [auto_null] = Autocorrelation(delta_null,steps-time_delay,maxlag);
    [auto_abs] = Autocorrelation(delta_abs,steps-time_delay,maxlag);
    [auto_null_abs] = Autocorrelation(delta_null_abs,steps-time_delay,maxlag);
    
    figure(16+20*comp)
    plot(startplot:1:maxlag,auto,'b')
    set_title(AUSWAHL, 14, ', autocorr') 
    set(gca,'XTick',0:maxlag/5:maxlag,'fontSize',12)
    hold on
    plot(startplot:1:maxlag,auto_null,'r:')
    hold off
    
     figure(17+20*comp)
    plot(startplot:1:maxlag,auto_abs,'b')
    set_title(AUSWAHL, 14, ', autocorr') 
    set(gca,'XTick',0:maxlag/5:maxlag,'fontSize',12)
    hold on
    plot(startplot:1:maxlag,auto_null_abs,'r:')
    hold off
  end 
  
%old_autocorrelation()
%does not work


  
end